#ifndef XMPlayer
#define XMPlayer


#define SOUND_COMMAND_MASK	0xfff0
#define SOUND_CH_MASK		0x000f
#define SOUND_SETPARAMS 0x80f0
// Module ID number
#define SOUND_DEV 0x00012345


#if 0
#define PRINTF(x) printf x
#else
#define PRINTF(x) 
#endif
#define ERROR(x) printf x
#define xPRINTF(x) 

#define BASE_priority  32

#define OLDLIB 0
#define TRANS_CH  0


#define XM_MONO 0
#define XM_STEREO 1

#define MD_id 0
#define MD_sngname  17
#define MD_trkname  21+17
#define MD_version  20+21+17
#define MD_hdsize   20+21+17+2
#define MD_snglen   20+21+17+2+4
#define MD_restart  20+21+17+2+4+2
#define MD_numchan  20+21+17+2+4+2+2
#define MD_numpat   20+21+17+2+4+2+2+2
#define MD_numins   20+21+17+2+4+2+2+2+2
#define MD_flags    20+21+17+2+4+2+2+2+2+2
#define MD_tempo    20+21+17+2+4+2+2+2+2+2+2
#define MD_bpm      20+21+17+2+4+2+2+2+2+2+2+2
#define MD_orders   20+21+17+2+4+2+2+2+2+2+2+2+2
#define MD_patstrt 20+21+17+2+4+2+2+2+2+2+2+2+2+256


typedef struct XMHEADER{
	u_short version;
	u_short songlength;               /* (word) Song length (in patten order table) */
	u_short restart;                  /* (word) Restart position */
	u_short numchn;                   /* (word) Number of channels (2,4,6,8,10,...,32) */
	u_short numpat;                   /* (word) Number of patterns (max 256) */
	u_short numins;                   /* (word) Number of instruments (max 128) */
	u_short flags;                    /* (word) Flags: bit 0: 0 = Amiga freq */
	u_short tempo;                    /* (word) Default tempo */
	u_short bpm;
	u_short XMChannels;
	u_short XMPSXChannels;
	u_long *JAP_PAT_ADDR[256];     /* Pattern Start Addresses (maxpatt*chnls)*/
	u_long *JAP_PAT_ADDR2[256];     /* Pattern Start Addresses (maxpatt*chnls)*/
	u_long *JAP_InstrumentOffset[128];
	u_long *JAP_SampAddr[128];
	u_long *JAP_SampHdrAddr[128];
	u_char jorders[256];		/* list of patterns */
	int	  S3MPanning;
} XMHEADER;


typedef struct XMCHANNEL{

	
	u_short Octave;
	short LVol;
	short RVol;
	short OldLVol;
	short OldRVol;
	u_short OldPeriod;
	u_char OldSample;
	u_long OldSOff;
	u_long SOffset;
	u_long LoopFlag;
	u_long LoopStart;
	u_char nothing;
	u_char ChDead;
	u_char panenvflg;		/* envelope flag */
	u_char panenvpts;		/* number of envelope points */
	u_char panenvsus;		/* envelope sustain index */
	u_char panenvbeg;		/* envelope loop begin */
	u_char panenvend;		/* envelope loop end */
	short panenvp;			/* current envelope counter */
	u_short panenva;		/* envelope index a */
	u_short panenvb;		/* envelope index b */
	u_short keyoffspd;
	u_char envflg;       /* envelope flag */
	u_char envpts;			/* number of envelope points */
	u_char envsus;			/* envelope sustain index */
	u_char envbeg;			/* envelope loop begin */
	u_char envend;			/* envelope loop end */
	short envp;				/* current envelope counter */
	u_short enva;			/* envelope index a */
	u_short envb;			/* envelope index b */

	u_char ins;
	u_char vol;
	u_char dat;
	u_char datold;
	u_char eff;
	u_char not;
	u_char oldvslide;
	u_char oldfvslide;
	u_char oldfslide;
	short fadevol;		/* fading volume */
	u_char keyon;		/* if 1=key is pressed. */
	u_char kick;	   	/* if 1=sample has to be restarted */
	u_char kick2;	   	/* if 1=sample has to be restarted */
	u_char sample;		/* which sample number (0-31) */
	short handle;		/* which sample-handle */
	u_long start;		/* The start byte index in the sample */
	u_char panning;		/* panning position */
	u_char pansspd;		/* panslide speed */
	u_char volume;		/* volume (0 - 64) to play the sample at */
	u_short period;		/* period to play the sample at */
	u_short SPUPitch;		/* period to play the sample at */
	char transpose;
	u_char note;
	short ownper;
	short ownvol;
	short UserVol;
	char retrig;		/* retrig value (0 means don't retrig) */
	u_short c2spd;		/* what finetune to use */
	u_char tmpvolume;	/* tmp volume  JAP */
	u_short tmpperiod;	/* tmp period */
	u_short wantedperiod;	/* period to slide to (with effect 3 or 5) */
	u_short slidespeed;	/* */
	u_short portspeed;	/* noteslide speed (toneportamento) */
	u_char s3mtremor;	/* s3m tremor (effect I) counter */
	u_char s3mvolslide;	/* last used volslide */
	u_char s3mrtgspeed;	/* last used retrig speed */
	u_char s3mrtgslide;	/* last used retrig slide */
	u_char glissando;	/* glissando (0 means off) */
	u_char wavecontrol;	/* */
	u_char vibpos;		/* current vibrato position */
	u_char vibspd;		/* "" speed */
	u_char vibdepth;		/* "" depth */
	u_char trmpos;		/* current tremolo position */
	u_char trmspd;		/* "" speed */
	u_char trmdepth;		/* "" depth */
	u_char SPUChannel;	/* SPU Channel to play sound on */
//108
				  
} XMCHANNEL;


typedef struct XMSONG{

	int	  HeaderNum;	
	int	  CurPos;			  /* Index into pattern data */
	u_short reppos;			  /* patternloop position */
	u_short repcnt;           /* times to loop */
	u_short vbtick;           /* tick counter */
	u_short patbrk;           /* position where to start a new pattern */
	u_char  patdly;           /* patterndelay counter */
	u_char  patdly2;          /* patterndelay counter */
	u_short numrow;           /* number of rows on current pattern */
	short   posjmp;           /* flag to indicate a position jump is needed*/
	u_short PatternPos;       /* current row number (0-255) */
	short   SongPos;          /* current song position */
	u_short CurrentPattern;
	u_short SongSpeed;        /* current songspeed */
	u_short SongBPM;
	int	  SongLoop;         /* loop module ? */
	u_char  SongVolume;	     /* song volume (0-128) */
	u_char  MasterVolume;	     /* song volume (0-128) */
	int	  XMActiveVoices;	  /* number of voices currently playing */
	int	  NotAmiga;
	u_char  XMPlay;
	int	  FirstCh;			  /* First SPU channel to playback on */	
	int	  JBPM;
	int	  PCounter;			  
	u_short PatSize;
	u_long *PatAdr;
	u_long *PatAdr2;
	int	  PlayMask;
	int	  SFXNum;
	XMCHANNEL XM_Chnl[32];	  /* max 32 channels per song*/
	short	  PlayNext;
	int  CurrentStart;
	u_char  VabID;
	short	  UserPan;
	u_char  MaxChans;
//2689
}XMSONG;


#define	XMEF_APPREGIO 0		/* Effects */
#define	XMEF_PORTUP 1
#define	XMEF_PORTDOWN 2
#define	XMEF_TONEPORT 3
#define	XMEF_VIBRATO 4
#define	XMEF_PORT_VOLSLD 5
#define	XMEF_VIB_VOLSLD 6
#define	XMEF_TREMELO 7
#define	XMEF_PANPOS 8
#define	XMEF_SAMPOFFSET 9
#define	XMEF_VOLSLD 10
#define	XMEF_POSJMP 11
#define	XMEF_VOLUME 12
#define	XMEF_PATBREAK 13
#define	XMEF_E 14
#define	XMEF_SETSPEED 15
#define	XMEF_GLOBALVOL 16
#define	XMEF_GLOBALVOLSLD 17
#define	XMEF_XM_VOLSLD 23
#define	XMEF_XM_PANSLD 24

#define	XMEF_E_FINESLD_UP 1	/* Effects from above E command */
#define	XMEF_E_FINESLD_DOWN 2
#define	XMEF_E_GLISSANDO 3
#define	XMEF_E_VIB_WAVE 4
#define	XMEF_E_FINETUNE 5
#define	XMEF_E_PATLOOP 6
#define	XMEF_E_TREM_WAVE 7
#define	XMEF_E_NOTUSED 8
#define	XMEF_E_RETRIG 9
#define	XMEF_E_FINEVOL_UP 10
#define	XMEF_E_FINEVOL_DOWN 11
#define	XMEF_E_CUTNOTE 12
#define	XMEF_E_NOTEDELAY 13
#define	XMEF_E_PATDELAY 14

/*Envelope flags*/

#define EF_ON           1
#define EF_SUSTAIN      2
#define EF_LOOP         4
 
typedef struct XM_HeaderInfo
{
		u_short	BPM;
		u_short	Speed;
} XM_HeaderInfo;

typedef struct XM_VABInfo
{
		u_char*		Address;
		u_long		Size;
} XM_VABInfo;

typedef struct XM_Feedback
{
		u_char	Volume;
		short		Panning;
		int		CurrentStart;
		short		PlayNext;
		u_short	SongLength;
		u_char	Status;
		u_short	PatternPos;
		short		SongPos;
		u_short	CurrentPattern;
		u_short	SongSpeed;
		u_short	SongBPM;
		int		SongLoop;
		int		ActiveVoices;
} XM_Feedback;

int xmplay_loop (void);
void EE_SdInit (int no_ch, int status);
void AdpcmSetParam(int ch, short *jdata);
void SetReturnBuffer(void);
void EE_XMInit(void);
void EE_GetVABID(void);
void EE_SetSPUBaseAddress(unsigned int address,unsigned int address2);
void EE_CreateTransferBuffer(void);
void EE_FreeTransferBuffer(void);
void EE_CreateSampleOffsetData(int V,int slot,u_short ad1,u_short ad2);
void EE_FreeXMPatternRAM(int xmd);
void EE_AllocXMSong(int Song);
void EE_AllocateXMPatternRAM(unsigned int s1,unsigned int s2,int xmd);
void EE_XMPlay(int V_ID,int X_ID,int S_ID,int firstchan,int loop,u_int bitmask,u_int bitmask2,int offset);
void EE_InitXMData(int id, int pan);
void EE_AllocXMBuffer(int id);
void EE_TransferSampleData(unsigned int size,unsigned int sizeb);
void EE_Pause(int songid);
void EE_Resume(int songid);
void EE_PauseAll(void);
void EE_ResumeAll(void);
void EE_FreeXMBuffer(int xmd);
void EE_XMQuit(int songid);
void EE_XMExit(void);
void EE_CloseSampleBank(int bank);
void EE_SetSongPos(int song,int pos);
void EE_SetChannelVolume(int songid,int channel,int volume);
void EE_FreeXMSong(int song);
void EE_SetMasterPan(int song,int pan);
void EE_SetMasterVol(int song,int vol);
void EE_SetBPM(int song,int bpm);
void EE_SetSpeed(int song,int speed);
void EE_SetMono(void);
void EE_SetStereo(void);
void EE_GetSongFeedback(int songid);


void XM_Restart(int Song_ID);
void XM_Pause(int Song_ID);
void XM_Exit(void);
void XM_Update(void);
void XM_PlayStop(int Song_ID);
void XM_PlayStart(int Song_ID,int PlayMask);
void XM_SetSongPos(int Song_ID,u_short pos);
int InitXMData(u_char *mpp,int XM_ID,int S3MPan);
int XM_VABInit(u_char* VHData,u_char* VBData);
void XM_OnceOffInit(void);
int  XM_Init(int VabID,int XM_ID,int SongID, int FirstCh,
				 int Loop,int PlayMask,int SFXNum);
int XM_GetChVolume(int Song_ID,int Channel);
void XM_SetChVolume(int Song_ID,int Channel,int Volume);
void XM_PlayNext(int Song_ID,short SongPos);
void XM_CloseVAB(int VabID);
void XM_SetMasterPan(int Song_ID,short Pan);
void XM_SetMasterVol(int Song_ID,u_char Vol);
void UpdateWithTimer(int SC);
void XM_DoFullUpdate(int SC);
void XM_Quit(int SongID);
void XM_StopSample(int channel);
void XM_PlaySample(int vid,int slot,int channel,int voll,int volr,int pitch);
int XM_GetFreeVAB(void);
void XM_SetVAGAddress(int VabID,int slot,int addr);
void XM_PauseAll(void);
void XM_RestartAll(void);
void XM_SetSongAddress(u_char *Address,int song);
int XM_GetSongSize(void);
void XM_FreeSongID(void);
void XM_SetSpeed(int Song_ID,u_short Speed);
void XM_SetBPM(int Song_ID,u_short BPM);
void XM_SetMono(void);
void XM_SetStereo(void);
void XM_FreeFileHeaderID(void);
void XM_SetFileHeaderAddress(u_char *Address,int id);
int XM_GetFileHeaderSize(void);



u_short GetLogPeriod(u_char note,u_short fine);
short ProcessPanEnvelope(short v,u_char keyon,int JSmp);
short ProcessEnvelope(short v,u_char keyon,int JSmp);
void StartPanEnvelope(u_char flg,u_char pts,u_char sus,u_char beg,u_char end);
void StartEnvelope(u_char flg,u_char pts,u_char sus,u_char beg,u_char end);
void UpdateXMData(void);
short DoVol(u_long a,short b,short c);
short DoPan(short envpan,short pan);
void DoVolSlide(u_char dat);
void DoTremolo(void);
void DoVibrato(void);
void DoToneSlide(void);
void DoS3MRetrig(u_char inf);
void DoXMPanSlide(u_char inf);
void DoXMVolSlide(u_char inf);
void Arpeggio(u_char dat);
void SetInstr(u_char inst);
void SetNote(u_char note);
void DoEEffects(u_char dat);
void SPE (u_char eff,u_char dat);
void JPlayEffects(void);
int JPlayNote(u_char *j,int pmsk);
u_long GetLong(u_char *mpp);
short GetSWord(u_char *mpp);
u_short GetWord(u_char *mpp);
short Interpolate(short p,short p1,short p2,short v1,short v2);
u_short JPGetPeriod(u_char note,short fine);
u_short GetPeriod(u_char note,u_short c2spd);
void SetPer(void);
long GetFreq2(long period);
void CurrentKeyStat(void);
void UpdateHardware(void);
int CnlStat(int Channel);
void StpCh(int Channel);
void SetFrq(int core,int Channel,int Pitch);
void SetVol(int core,int Channel,int LVol,int RVol);
void PlaySFX(int VBID,int Channel,int Inst,int Pitch,int LV,int RV);
void ClearSPU(int VBID);
int SendVAGsToRAM(u_char *Header,u_char *Body);
void InitSPUChannel(int Channel);
void SilenceXM(int Song_ID);
void UpdateEffs(void);
void ApplyEffs(void);
void UpdatePatternData(int SC);
int IntVols(int Vol1,int Vol2);
int GetFreeSongID(void);
void JPClearSPUFlags(int SongID);
int CalcPlayPos(int StartPos);
int JCalcPat(u_char *j);
int PACKEDCalcPlayPos(int StartPos);
void UpdateXMData2(void);
int SetCore(int Chnl);
void UpdateWithTimer2(int SC);

#endif




